/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)
    This file is part of Otashi.
*****************************************************************************************/
// Game-Headerdatei

#ifndef CHIPS_H
#define CHIPS_H

#include "config.h"
#include <qcanvas.h>
#include <qtimer.h>
#include <qfile.h>

class stein
{
  public:
  stein(int,int,int);
  QCanvasSprite* p_sprite;
  
  void set_parms(int,int,int);
  void zeige();
  void loesche();
  int get_hg();
  int get_vg();
  int get_patt();
  int get_pic();
  
  private:
  int vg,hg,patt,pic;
};



class chips:public QCanvas
{
  Q_OBJECT
  
  private:
  int nvg,nhg,npatt,tic;
  int b[SMAX];    
  QTimer* my_timer;
  QTimer* my_stopper;
  
  public:
  chips(QWidget* parent=0);
  QCanvasPixmapArray* my_chipsarray;
  QCanvasPixmapArray* my_bgarray;
  QCanvasPixmapArray* my_goverarray;
  QCanvasPixmapArray* my_pausearray;
  QCanvasSprite* p_pause;
  QCanvasSprite* p_gover;
  QCanvasSprite* p_cursor;
  QCanvasSprite* p_bgsprite[SMAX]; 
  stein* my_stein[SMAX];
  stein* my_vorrat[NUMVORRAT]; 
  
  private:
  bool aktiv,pausiert;
  int punkte,punkte0,level,zeit,gewaehlt;
  
  void reset_timer();
  void weiter();
  bool updat_level(int);
  bool is_gueltig(int);
  bool passt(stein*,stein*);
  void setze_chip(int);
  void updat_vorrat();
  void steincopy(stein*,stein*);
  void stein_setzen(int);
  bool check_ende();
  bool chamaeleon(int);
  bool wandler(int,bool);
  int rollen(int);

  
  public slots:
  void neues_spiel();
  void pause();
  void klick(int,int);
  void moven(int,int);
  void ticken();
  void rutschen_lassen();
  void starte_level();
  void restart_level();
  void game_over();
  void lade_spielstand(int);
  void speichere_spielstand(int);
  void save_settings(int);
  
  signals:
  void gameover(int);
  void punkte_changed(int);
  void ticker_changed(int);
  void zeit_changed(int);
  void level_changed(QString);
};

#endif
