/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)
    This file is part of otashi which runs under GPL.
*****************************************************************************************/

// 15.09.2004 uja: Verbreiteung dr Anzeige fuer laengere Labelnamen

#include "window.h"

// 2-spaltiges Layout fuer quadratische Spielfelder, Anzeigen rechts:
// ------------------------------------------------------------------ 

window::window(QWidget *parent,char* name): QHBox(parent,name)
{ 
// allgemeines Aussehen:
  this->setMargin(16);
  this->setSpacing(4);
  this->setPaletteBackgroundColor(BACKGR0);
  this->setBackgroundPixmap(QPixmap(BACKPIX0));
  this->setCaption(TITEL);  
//  this->setMaximumSize(WIN_BMAX,WIN_HMAX);
  this->setMinimumSize(WIN_BMIN,WIN_HMIN);
  QPalette my_pal=QPalette(this->palette());  
  my_pal.setColor(QColorGroup::Light,RANDHCOLOR);
  my_pal.setColor(QColorGroup::Dark,RANDDCOLOR);
  this->setPalette(my_pal);

  QLabel* p_spaltel=new QLabel(this); p_spaltel->setText(""); p_spaltel->setBackgroundPixmap(QPixmap(BACKPIX0)); 


// erste Spalte: Canvasview (Spielfeld)
  QVBox* p_spalte0=new QVBox(this);
  p_spalte0->setSpacing(8);
  p_spalte0->setBackgroundPixmap(QPixmap(BACKPIX0));
  my_view=new viewport(p_spalte0,"playfield"); // QCanvasView/QScrollView-Variante
  my_view->show(); 

// zweite Spalte: Steinvorrat, Titel, darunter Anzeigentafel als 2-spaltiges Gitter:  
  QVBox* p_spalte1=new QVBox(this);
  p_spalte1->setSpacing(8);
  p_spalte1->setMargin(12);
  p_spalte1->setMaximumWidth(240);
  p_spalte1->setBackgroundPixmap(QPixmap(BACKPIX0));

  QLabel* p_spacero=new QLabel(p_spalte1);  p_spacero->setText(""); p_spacero->setBackgroundPixmap(QPixmap(BACKPIX0)); 

// Vorratsbox mit (verkleinertem) Viewport fuer 5 Sprites und Titelpic
  QHBox* p_spalte1a=new QHBox(p_spalte1);  
  p_spalte1a->setBackgroundPixmap(QPixmap(BACKPIX0));
  my_view2=new viewport(p_spalte1a,"talon"); // QCanvasView-Variante
  my_view2->setMinimumSize(DX+4,NUMVORRAT*DY+12);              // feste Feldgroesse setzen
  my_view2->setMaximumSize(DX+4,NUMVORRAT*DY+12);
  my_view2->show(); 
  QLabel* p_ue =new QLabel(p_spalte1a);
  p_ue->setBackgroundPixmap(QPixmap(BACKPIX0));
  p_ue->setPixmap(QPixmap(TITELBILD)); 

  QGrid* p_anzeigen=new QGrid(2,p_spalte1,"anzeigen");  // Anzeigetafel
  p_anzeigen->setSpacing(8);
  p_anzeigen->setPaletteBackgroundColor(BACKGR2);
  p_anzeigen->setPaletteBackgroundPixmap(QPixmap(BACKPIX2));
  p_anzeigen->setPaletteForegroundColor(COLOR2);
  p_anzeigen->setMinimumSize(192,64);
  p_anzeigen->setMaximumSize(240,128);
  p_anzeigen->setFrameShadow(Raised);
  p_anzeigen->setFrameShape(Panel);
  p_anzeigen->setMargin(12);
  // Daten einfuellen  
  QLabel* p_llevel =new QLabel(_LLEVEL,p_anzeigen); p_level  =new QLabel(p_anzeigen); 
  QLabel* p_lzeit  =new QLabel(_LTIME,p_anzeigen);  p_zeit   =new QLabel(p_anzeigen); 
  QLabel* p_lpunkte=new QLabel(_LSCORE,p_anzeigen); p_punkte =new QLabel(p_anzeigen); 
  QLabel* p_nix=new QLabel("",p_anzeigen); QLabel*  p_icke=new QLabel("by uja",p_anzeigen);
  // CPP-Patch (datt darf ja woll ich wahr sein!!!):  irgendein Quatsch, damit der Compiler die Schnauze haelt
  bool cpppatsch; cpppatsch=((p_llevel) && (p_lzeit) && (p_lpunkte) && (p_icke) && (p_nix));  
  QLabel* p_spaceru=new QLabel(p_spalte1);  p_spaceru->setText(""); p_spaceru->setBackgroundPixmap(QPixmap(BACKPIX0)); 
  
  p_spalte1->setStretchFactor(p_spacero,2);
  p_spalte1->setStretchFactor(p_spalte1a,4);
  p_spalte1->setStretchFactor(p_anzeigen,2);
  p_spalte1->setStretchFactor(p_spaceru,2);

  QLabel* p_spalte2=new QLabel(this); p_spalte2->setText(""); p_spalte2->setBackgroundPixmap(QPixmap(BACKPIX0)); 
  
  setStretchFactor(p_spaltel,2);
  setStretchFactor(p_spalte0,5);
  setStretchFactor(p_spalte1,1);
  setStretchFactor(p_spalte2,2);
  

}

// Slots: - nicht benoetigte Slots stoeren erstmal nicht
void window::set_punkte(int p)    { p_punkte->setNum(p); }
void window::set_zeit(int p)      { p_zeit->setNum(p);   }
void window::set_level(QString p) { p_level->setText(p); }

// =================================================================================================================================
